
namespace McpStudy.McpServerStreamableHttp;

public class Program
{
    private static Pipe _input = new Pipe();
    private static Pipe _output = new Pipe();

    public static void Main(string[] args)
    {
        var builder = WebApplication.CreateBuilder(args);

        // Add services to the container.

        builder.Services.AddControllers();

        // Learn more about configuring OpenAPI at https://aka.ms/aspnet/openapi
        builder.Services.AddOpenApi();

        builder.Services
            .AddMcpServer(options =>
            {
                options.ServerInfo = new Implementation
                {
                    Name = "StudyMCPServer",
                    Version = "1.0.0"
                };
            })
            .WithHttpTransport(options => options.Stateless = true)
            .WithToolsFromAssembly(typeof(McpStudy.Core.TimeTools).Assembly)
            .WithToolsFromAssembly(typeof(Program).Assembly);


        var app = builder.Build();

        // Configure the HTTP request pipeline.
        app.MapOpenApi();

        app.UseSwaggerUI(options =>
        {
            options.SwaggerEndpoint("/openapi/v1.json", "v1");
        });

        app.UseAuthorization();


        app.MapControllers();

        //ַ(֧վ):Զм+ض
        //ֻм·(app.Map): /  "" ȱapp.MapMcp
        app.Use(async (context, next) =>
        {
            if (context.Request.Path == "/" || context.Request.Path == "")
            {
                context.Response.ContentType = "text/html";
                await context.Response.SendFileAsync(Path.Combine(app.Environment.ContentRootPath, "index.html"));
            }
            else
            {
                await next();
            }
        });

        app.MapMcp();

        app.Run();
    }
}
